/* 
 * File:   AttackView.cpp
 * Author: Miguel
 * 
 * Created on 14 de enero de 2012, 18:17
 */

#include "AttackView.h"
#include "Evt_Mover.h"
#include "Evt_QuitarJuego.h"

AttackView::AttackView(Attack* attack) {
    mAttack=attack;
    mRemoved=false;
}

void AttackView::VOnUpdate( int deltaMilliseconds ) {
    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
    if (mAttack->isActive()) {
        mAttack->update(deltaMilliseconds);
        evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mAttack,Ogre::Vector3(0,0,500))));
    }    
    else if (!mRemoved){
        mRemoved=true;
        evtMgr->queueEvent(GardeGames::EventPtr( new Evt_QuitarJuego(this,mAttack)));
    }
}
    
bool AttackView::isFinished() {
    mAttack->isActive();
}

AttackView::~AttackView() {
}

