/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include "Attack.h"


//! Clase que encapsula el comportamiento de los ataques.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Controla el comportamiento de los ataques heredando de IGameView.
 *  Aunque actualmente lo único que hace un ataque es avanzar en línea recta y desaparecer al chocar,
 *  se podrían establecer otros comportamientos, como movimiento parabólico,
 *  proyectil perseguidor, aumentar la fuerza del ataque con el tiempo, etc.
 */

class AttackView : public GardeGames::IGameView {
    friend class HumanViewListener;
public:
    AttackView(Attack* attack);
    
    //heredadas
    GameViewType VGetType(){return GardeGames::IGameView::GameView_Other;};
    GameViewId VGetId() const {return 0;};
    void VOnUpdate( int deltaMilliseconds );
    
    bool isFinished();
    
    virtual ~AttackView();
    
private:
    
    Attack* mAttack;
    bool mRemoved;

};


