/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <Ogre.h>

//! Clase que representa cualquier objeto dentro del juego.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Representa todo tipo de objetos que puedan situarse en el juego.
 *  
 *  Esta clase está hecha para guardar, de forma minimalista,
 *  la información de los objetos que hay en el juego.
 *  La intención es usarla para un editor de escenarios (poder guardar y leer ficheros fácilmente).
 */

class Elemento
{
public:
	Elemento(int tipo, Ogre::Vector3 posicion);
	~Elemento(void);

	int mTipo; //indica la clase (casa, ogro, robot, ninja...)
	Ogre::Vector3 mPosicion;
};
