/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
//#include "EventType.h"
#include <Ogre.h>

#include "Creature.h"
#include "Attack.h"

//! Clase encargada de comenzar ataques de ray casting.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Evento que solicita raycasting para lanzar ataques perseguidores.
 *  No se han implementado en esta versión del juego, de modo que no se usan.
 */

class Evt_ComenzarAtaque : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_ComenzarAtaque(Creature *atacante, Attack* ataque);
	~Evt_ComenzarAtaque(void);

	Creature *mAtacante;
	Attack* mAtaque;
};
