/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include <Ogre.h>

#include "Creature.h"

//! Clase encargada de las peticiones de movimiento.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Evento disparado por las vistas de los actores para solicitar su desplazamiento.
 *  La clase estado jugando lo captura y aplica el movimiento como deba.
 *  Aunque no hay, se podrían implementar actores que capturaran este tipo de movimientos,
 *  como por ejemplo minas de proximidad u hogueras.
 */

class Evt_Mover : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_Mover(GameActor *elemento, Ogre::Vector3 desplazamiento);
	~Evt_Mover(void);

	GameActor *mElemento;
	Ogre::Vector3 mDesplazamiento;

};
