/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include "GameActor.h"

//! Clase encargada de solicitar la destrucción de la criatura.


/**
 *  @author Miguel Garde Vallés
 *  @date 26-02-2012
 *
 *  Evento disparado por las vistas de las criaturas cuando éstas han terminado de morir (la animación de muerte ha terminado).
 *  El evento es recogido por la clase EstadoJugando,
 *  que se encarga de hacer las llamadas necesarias para eliminar la criatura, liberar memoria, etc.
 */

class Evt_QuitarJuego : public GardeGames::Event
{
public:
    static char const * const gkName;
    
    Evt_QuitarJuego(GardeGames::IGameView* vista, GameActor* gameActor);
    virtual ~Evt_QuitarJuego();
    
    GardeGames::IGameView* mVista;
    GameActor* mGameActor;
private:

};


