/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include <Ogre.h>

#include "Creature.h"

//! Clase encargada de transmitir lo que una criatura ve.


/**
 *  @author Miguel Garde Vallés
 *  @date 19-01-2012
 *
 *  Evento disparado por EstadoJugando en respuesta a un evento de tipo Evt_Ver.
 *  La clase EstadoJugando detecta qué actores están dentro del campo de visión de la criatura,
 *  y se lo notifica con este evento pasándole una lista de las cosas vistas.
 */

class Evt_Visto : public GardeGames::Event
{
public:
	static char const * const gkName;
	Evt_Visto(Creature *elemento, std::vector<GameActor*> resultado);
	~Evt_Visto(void);

	Creature * mCreature;
	std::vector<GameActor*> mResultado;
};
