// InputManager.cpp

#include "InputManager.h"

using namespace std;

namespace GardeGames
{


	InputManager::InputManager() {
		

		for (int i = 0; i < NUM_TECLAS; i++)
		{
			accionesTeclas[i]=0;//new GameAction("NULL",GameAction::NORMAL);
		}

		for (int i = 0; i < NUM_MOUSE_CODES; i++)
		{
			accionesRaton[i]=0;//new GameAction("NULL",GameAction::NORMAL);
		}

		mRatonX=0;
		mRatonY=0;

	}

	InputManager::~InputManager() {
	}

	void InputManager::setKeyboard(OIS::Keyboard *mKeyboard) {
		teclado=mKeyboard;
		//this->keyListener=mKeyboard->getEventCallback();
		teclado->setEventCallback(this);
	}

	void InputManager::setMouse(OIS::Mouse *mMouse) {
		raton=mMouse;
		raton->setEventCallback(this);
	}

	void InputManager::mapToKey(GameAction *accion, OIS::KeyCode key) {
		accionesTeclas[(int)key]=accion;
	}

	void InputManager::mapToMouse(GameAction *accion, int codigo) {
		accionesRaton[codigo]=accion;
	}

	void InputManager::clearAllMaps() {
		for (int i = 0; i < NUM_TECLAS; i++)
		{
			accionesTeclas[i]=0;//new GameAction("NULL",GameAction::NORMAL);
		}

		for (int i = 0; i < NUM_MOUSE_CODES; i++)
		{
			accionesRaton[i]=0;//new GameAction("NULL",GameAction::NORMAL);
		}
	}

	GameAction* InputManager::getKeyAction(OIS::KeyCode key) {
		return accionesTeclas[(int)key];
    }

	bool InputManager::keyPressed( const OIS::KeyEvent &e ) {
		GameAction* gameAction = getKeyAction(e.key);
        if (gameAction!=0) {
            gameAction->press();
        }  
/*
		if (mStateManager->currentState) {
			mStateManager->currentState->keyPressed(e);
		}
*/
		return true; 
	}  
	
	bool InputManager::keyReleased( const OIS::KeyEvent &e ) {
		GameAction* gameAction = getKeyAction(e.key);
        if (gameAction!=0) {
			gameAction->release();
        }	
/*
		if (mStateManager->currentState) {
			mStateManager->currentState->keyReleased(e);
		}
*/
		return true; 
	}

	bool InputManager::mouseMoved( const OIS::MouseEvent &arg ){
        mouseHelper(MOUSE_MOVE_LEFT, MOUSE_MOVE_RIGHT, arg.state.X.rel);
        mouseHelper(MOUSE_MOVE_UP, MOUSE_MOVE_DOWN, arg.state.Y.rel);
        
		mouseHelper(MOUSE_WHEEL_UP, MOUSE_WHEEL_DOWN,arg.state.Z.rel);

		mDesplazamientoX = arg.state.X.rel;
		mDesplazamientoY = arg.state.Y.rel;

		mRatonX = arg.state.X.abs;
        mRatonY = arg.state.Y.abs;
/* 
		if (mStateManager->currentState) {
			mStateManager->currentState->mouseMoved(arg);
		}
*/
		return true;
	}

	bool InputManager::mousePressed( const OIS::MouseEvent &arg, OIS::MouseButtonID id ){
		GameAction *gameAction = getMouseButtonAction(id);
        if (gameAction!=0) {
            gameAction->press();
        }
/*
		if (mStateManager->currentState) {
			mStateManager->currentState->mousePressed(arg,id);
		}
*/
		return true;
	}

	bool InputManager::mouseReleased( const OIS::MouseEvent &arg, OIS::MouseButtonID id  ){
		GameAction *gameAction = getMouseButtonAction(id);
        if (gameAction!=0) {
            gameAction->release();
        }
	 
/*		if (mStateManager->currentState) {
			mStateManager->currentState->mouseReleased(arg,id);
		}
*/
		return true;
	}

	int InputManager::getMouseX() {
		return mRatonX;
	}

	int InputManager::getMouseY() {
		return mRatonY;
	}

	int InputManager::getMouseRelativeX() {
		return mDesplazamientoX;
	}

	int InputManager::getMouseRelativeY() {
		return mDesplazamientoY;
	}

	void InputManager::capture() {
		teclado->capture();
		raton->capture();
	}

	void InputManager::mouseHelper(int codeNeg, int codePos,
            int amount)
        {
            GameAction *gameAction;
            if (amount < 0)
            {
                gameAction = accionesRaton[codeNeg];
            }
            else
            {
                gameAction = accionesRaton[codePos];
            }
            if (gameAction!=0)
            {
				gameAction->press(Ogre::Math::Abs(amount));
                gameAction->release();
            }
        }

	int InputManager::getMouseButtonCode(OIS::MouseButtonID id) {
         switch (id) {
			 case OIS::MB_Left:
                return MOUSE_BUTTON_LEFT;
			 case OIS::MB_Right:
                return MOUSE_BUTTON_RIGHT;
			 case OIS::MB_Middle:
                return MOUSE_BUTTON_MIDDLE;
            default:
                return -1;
        }
    }

	GameAction* InputManager::getMouseButtonAction(OIS::MouseButtonID id) {
        int mouseCode = getMouseButtonCode(id);
        if (mouseCode != -1) {
             return accionesRaton[mouseCode];
        }
        else {
             return 0;
        }
    }


}
