#include "HumanViewListener.h"
#include "Evt_Mover.h"
#include "Evt_Sonido.h"
#include "Evt_Atacado.h"
#include "Evt_Muerto.h"
#include "GestorSonido.h"

HumanViewListener::HumanViewListener(HumanView * hv)
{
	mHumanView=hv;
}

HumanViewListener::~HumanViewListener(void)
{
}
/*
char const * GetName(void) {
	return "HumanViewListener";
}
*/
bool HumanViewListener::HandleEvent( GardeGames::Event & evento ) {
	
        GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
	if (stricmp(evento.getType().getStr(),Evt_Sonido::gkName)==0) {
		Evt_Sonido evt=dynamic_cast<Evt_Sonido &>(evento);
                if (evt.mType==Evt_Sonido::None) {          
                    if (evt.mSource->getType()!=GameActor::Attack) {
                        Creature* cr=dynamic_cast<Creature*>(evt.mSource);
                        GestorSonido::getSingletonPtr()->stopSounds(cr->getSoundList());
                    }
                }
                else if (evt.mSource->getPosition().distance(mHumanView->mJugador->getPosition())<1000) {
                    if (evt.mSource->getType()!=GameActor::Attack) {
                        Creature* cr=dynamic_cast<Creature*>(evt.mSource);
                        GestorSonido::getSingletonPtr()->playSound(mHumanView->mCameraPivot,evt.mSource->getNode(),evt.mSound,evt.mLooping,cr->getSoundList());
                    }
                    else {
                        GestorSonido::getSingletonPtr()->playSound(mHumanView->mCameraPivot,evt.mSource->getNode(),evt.mSound,evt.mLooping);
                    }
                }
	}
        else if (stricmp(evento.getType().getStr(),Evt_Atacado::gkName)==0)  {
            Evt_Atacado evt=dynamic_cast<Evt_Atacado &>(evento);
            if (evt.mAtacado->getId()!=mHumanView->mJugador->getId()) 
            { //si no es para nosotros nos vamos
                return false;
            }
            mHumanView->mJugador->getDamage(evt.mDamage*3);
            
            Ogre::Real ratio = (Ogre::Real)mHumanView->mJugador->mActualHealth / (Ogre::Real)mHumanView->mJugador->mMaxHealth;
    
            if (ratio < 0.0f)
                ratio = 0.0f;

            mHumanView->mLifeBar->setWidth(0.25*ratio);
            //printf("Golpeado!!\n");
            
            if (mHumanView->mJugador->mActualHealth<=0) {
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Muerto(mHumanView->mJugador)));
                mHumanView->mJugador->setState(Creature::DIE,false);
            }
        }
	//mHumanView->mJugador->translate(Ogre::Vector3(0,5,0));
	
	return false;
}
