/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GardeGames/GardeGames.h"
#include "HumanView.h"

//! Clase que recoge y procesa los eventos que a la vista humana le pueden interesar.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Implementa IEventListener para procesar diferentes eventos que interesan a la vista humana,
 *  ya sean para la criatura (eventos de recibir daño para quitar vida y cambiar la barra de la interfaz)
 *  como para el jugador (eventos de sonido para reproducir por los altavoces a un volumen concreto)
 */

class HumanViewListener : public GardeGames::IEventListener
{
public:
	HumanViewListener(HumanView * hv);
	~HumanViewListener(void);

	// heredadas
	bool HandleEvent( GardeGames::Event & evento );
	virtual char const * GetName(void){return "HumanViewListener";}

	HumanView *mHumanView;
};
