#include "AIView.h"
#include "utils.h"


AIView::AIView(Creature *criatura, Ogre::Billboard* lifeBar)
{
	mCreature=criatura;
        mLifeBar=lifeBar;

	/*inicializamos la velocidad*/
	velocity= Ogre::Vector2(0,0);
         steeringForceX=0;
	steeringForceY=0;
	desiredVelocityX=0;
	desiredVelocityY=0;

	

    closestObstacle=0;
    target=0;
    timeSinceLastFrame=0.003;
    timeSinceLastAttack= MIN_TIME_BETWEEN_ATTACKS;
    
    Attacking=false;
    
    
}

AIView::~AIView(void)
{
	if(mCreature) {
		delete mCreature;
	}
}

bool AIView::isClosestObstacle(){return closestObstacle;}

Ogre::Vector2 AIView::getVelocity()
{
	return velocity; 
}

Ogre::Vector3  AIView::getArrivingPoint()
{
    return arrivingPoint;
}

bool AIView::isAttacking()
{
    return Attacking;
}

bool AIView::facingTarget()
{
    
    Ogre::Vector2 posTarget=localPosition(Ogre::Vector2(target->getPosition().x,target->getPosition().z),getCreature()->getPosition(),getCreature()->getOrientation());
    if (posTarget.y>=0)
    {
        return true;
        
    }
    else
    {
        return false;
    }
    
}

 
Creature * AIView::getCreature()
{
	return mCreature; 
}
Creature *AIView::getTarget()
{
  return target;
}

StaticActor *AIView::getClosestObstacle()
{
	return this->closestObstacle;
}
void AIView::setVelocityX(double velocityX)
{
	velocity.x=velocityX;
}

void AIView::setVelocityY(double velocityY)
{
	velocity.y=velocityY;
}


void AIView::setNavigationMesh(navigationMesh* navigationMesh) {
    _navigationMesh = navigationMesh;
    Ogre::Vector3 position = getCreature()->getPosition();
    position.y = 0;
    _currentCell = _navigationMesh->findCell(position);
    int kkl=2;
}


Ogre::Vector2  AIView::addForce(Ogre::Vector2 steeringForce)
	 {
   
		//calculamos la steering force  para llegar a la velocidad deseada

		//calculamos la aceleraci�n

		 steeringForceX=steeringForce.x;
		  steeringForceY=steeringForce.y;

		Ogre::Vector2 acceleration=steeringForce/0.025;
		
		double time=getTimeSinceLastFrame();

		double vx=getVelocity().x+acceleration.x*getTimeSinceLastFrame();
		double vy=getVelocity().y+acceleration.y*getTimeSinceLastFrame();

		if (mCreature->getType()==0)
		{
			int c=1;
		}
		
		if (vx>=0)
		{
			setVelocityX(minimo(vx,mCreature->getMaxSpeed()));
		}
		else
		{
			setVelocityX(maximo(vx,-mCreature->getMaxSpeed()));
		}
       //
		if (vy>=0)
		{
			setVelocityY(minimo(vy,mCreature->getMaxSpeed()));
		}
		else
		{
			setVelocityY(maximo(vy,-mCreature->getMaxSpeed()));
		}

		Ogre::Vector2 aux=getVelocity();
	
		//poner esa velocidad en el sistema de coordenadas

		return localVelocity(Ogre::Vector2(getVelocity().x,getVelocity().y),mCreature->getOrientation());
        	
	 }

double AIView::getTimeSinceLastFrame()
{
	return timeSinceLastFrame;
}

void AIView::setTimeSinceLastAttack(double time)
{
    timeSinceLastAttack=time;
}

double AIView::getTimeSinceLastAttack()
{
	return timeSinceLastAttack;
}

 bool AIView::isClosestTarget()
 {
     if (getCreature()->getPosition().squaredDistance(target->getPosition())<(MIN_TARGET_DISTANCE*MIN_TARGET_DISTANCE))
     {
         return true;
     }
     else
     {
         return false;
     }
 }

bool AIView::canAttack()
{
    if ( (getTimeSinceLastAttack()>=MIN_TIME_BETWEEN_ATTACKS) && facingTarget() && isClosestTarget())
    {
        return true;
    }
    else
    {
        return false;
    }
    
}

bool AIView::canDamage()
{
    if ( getTimeSinceLastAttack()>=MIN_TIME_BETWEEN_DAMAGE)
    {
        return true;
    }
    else
    {
        return false;
    }
    
}
