/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewDeer.h"
#include "AIViewDeerListener.h"
#include "../Evt_Mover.h"
#include "../Evt_Ver.h"
#include "../Evt_Visto.h"
#include "../Evt_Atacado.h"
#include "../Evt_QuitarJuego.h"
#include "SteeringBehaviors.h"

AIViewDeer::AIViewDeer(Creature *creature,Ogre::Billboard* lifeBar)
	: AIView(creature,lifeBar)
{

        mDead=false;

	GardeGames::EventListenerPtr listener ( new AIViewDeerListener(this) ); //creamos su listener
	
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Mover::gkName) ); //lo asociamos a eventos de movimiento
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Ver::gkName) );
	//evtMgr->addListener( listener, GardeGames::EventType(Evt_Morir::gkName) );

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Visto::gkName) );
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Atacado::gkName) ); 


	//set up the steering behavior class 
    //set up state machine
    m_pStateMachine = new StateMachine<AIViewDeer>(this);  
    m_pStateMachine->SetCurrentState(Wandering::Instance());


   m_pSteering=new SteeringBehaviors(this);
   getSteeringBehaviors()->wanderOn();
  

}

AIViewDeer::~AIViewDeer(void)
{
	if(mCreature) {
		delete mCreature;
	}
}

SteeringBehaviors* AIViewDeer::getSteeringBehaviors()
{
	return this->m_pSteering;
}
void AIViewDeer::VOnUpdate( int deltaMilliseconds ) 
{
	
    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
    if (!mCreature->isAlive() || mDead)
    {
	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_QuitarJuego(this,mCreature)));
        return;
    }
       /*envio el evento de ver*/

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Ver(mCreature,100,15)));
	

	mCreature->update(deltaMilliseconds);

	timeSinceLastFrame=(double)deltaMilliseconds/1000;

        m_pStateMachine->Update();

}