/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "../GardeGames/GardeGames.h"
#include <Ogre.h>
#include "StateMachine.h"
#include "DeerOwnedStates.h"
#include "AIView.h"

/**
 *  @author Hector Agustin Lana
 *  @date 14-01-2012
 *
 *  Esta clase modela una vista de inteligencia artificial para un ciervo.
 *  Hereda de AIView
 *  
 */

class AIViewDeer : public AIView
{
	friend class AIViewDeerListener;
	
public:

	AIViewDeer(Creature *creature,Ogre::Billboard* lifeBar);
	~AIViewDeer(void);

	void VOnUpdate( int deltaMilliseconds );

	StateMachine<AIViewDeer>* GetFSM()const{return m_pStateMachine;}
	

	StateMachine<AIViewDeer>*  m_pStateMachine;

	SteeringBehaviors* m_pSteering;
	SteeringBehaviors* getSteeringBehaviors();
        bool mDead;

};
