/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewDeerListener.h"
#include "AIViewDeer.h"
#include "AIView.h"
#include "../Evt_Mover.h"
#include "../Evt_Visto.h"
#include "../Evt_Atacado.h"
#include "../Evt_Muerto.h"
#include "../Creature.h"

AIViewDeerListener::AIViewDeerListener(AIViewDeer * aiv)  :AIViewListener(aiv)
{
	mAIViewDeer=aiv;
	
}

AIViewDeerListener::~AIViewDeerListener(void)
{
}

bool AIViewDeerListener::HandleEvent( GardeGames::Event & evento ) {

	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
         std::vector<GameActor*> obstaculosVistos;
	if (stricmp(evento.getType().getStr(),Evt_Visto::gkName)==0) 
	  { //si veo a alguien empiezo a vagar
                 //printf("Criatura ve algo!\n");
		 Evt_Visto evt=dynamic_cast<Evt_Visto &>(evento);
		 if (evt.mCreature->getId()!=mAIView->getCreature()->getId()) 
		   { //si no es para nosotros nos vamos
			  return false;
		   }
		 while (!evt.mResultado.empty())
		 {
			 GameActor * actualActor=evt.mResultado.back();
			 int tipo =actualActor->getType();
			 if ((tipo==1)|| (tipo==2) )//si es el jugador o un lobo
			 {
                             Creature *actualCreature=static_cast<Creature*>(actualActor);
                              if (actualCreature->isAlive())
                                      
                               {
				if (!mAIViewDeer->GetFSM()->isInState(*Evading::Instance()))
				{
				     
				      mAIViewDeer->GetFSM()->ChangeState(Evading::Instance());
					  mAIViewDeer->target=static_cast<Creature*>(actualActor);
					  //si no estaba huyendo que huya	
					  if (mAIViewDeer->GetFSM()->isInState(*Wandering::Instance()))
					  {
					  	 mAIViewDeer->GetFSM()->ChangeState(Evading::Instance());
					  }
				}
                              }

		         }
                         else if (tipo==GameActor::House)
                          {
                              obstaculosVistos.push_back(actualActor);
                          }
                          else
                          {
                              
                          }

			  evt.mResultado.pop_back();

	    }
                  //ACTUALIZAR LA PERCEPCIÓN DE OBSTACULOS 
                    UpdateObstaclesPerception(obstaculosVistos);
                 
	
	}
    else if (stricmp(evento.getType().getStr(),Evt_Atacado::gkName)==0)  {
            Evt_Atacado evt=dynamic_cast<Evt_Atacado &>(evento);
            if (evt.mAtacado->getId()!=mAIView->getCreature()->getId()) 
            { //si no es para nosotros nos vamos
                return false;
            }
            mAIView->mCreature->getDamage(evt.mDamage*30);
            
            Ogre::Real ratio = (Ogre::Real)mAIView->mCreature->mActualHealth / (Ogre::Real)mAIView->mCreature->mMaxHealth;
    
            if (ratio < 0.0f)
                ratio = 0.0f;

            mAIView->mLifeBar->setDimensions(10*ratio,1);
            Ogre::Vector3 pos=mAIView->mLifeBar->getPosition();
            mAIView->mLifeBar->setColour(Ogre::ColourValue(255-ratio*10,ratio*10,0));
            
            if (mAIView->mCreature->mActualHealth<=0) {
                evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Muerto(mAIView->mCreature)));
                mAIView->mCreature->setState(Creature::DIE,false);
            }
        }
         else if (stricmp(evento.getType().getStr(),Evt_Muerto::gkName)==0)
         {
            
            if (mAIViewDeer->GetFSM()->isInState(*Evading::Instance()))
            {
              Evt_Muerto evt=dynamic_cast<Evt_Muerto &>(evento);
              Creature *criaturaMuerta=evt.mElemento;
              if (criaturaMuerta->getId()==mAIViewDeer->getTarget()->getId())
               {
                
                      mAIViewDeer->GetFSM()->ChangeState(Wandering::Instance());
                      mAIViewDeer->target=0;
               }
            
                 
             }   
          }     

	return false;
}