/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "AIViewSoldier.h"
#include "AIViewSoldierListener.h"
#include "../Evt_Mover.h"
#include "../Evt_Ver.h"
#include "../Evt_Visto.h"
#include "SteeringBehaviors.h"

#include <fstream>
#include <iostream>
#include <string>
#include <algorithm>



using namespace std; 


AIViewSoldier::AIViewSoldier(Creature *creature, Ogre::Billboard* lifeBar)
	: AIView(creature,lifeBar)
{

     
	GardeGames::EventListenerPtr listener ( new AIViewSoldierListener(this) ); //creamos su listener
	std::vector<GameActor*> obstaculosVistos;
	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Mover::gkName) ); //lo asociamos a eventos de movimiento
	evtMgr->addListener( listener, GardeGames::EventType(Evt_Ver::gkName) );
	//evtMgr->addListener( listener, GardeGames::EventType(Evt_Morir::gkName) );

	evtMgr->addListener( listener, GardeGames::EventType(Evt_Visto::gkName) );
	//evtMgr->addListener( listener, GardeGames::EventType(Evt_Atacado::gkName) ); 

	

	//set up the steering behavior class 
      //set up state machine
      m_pStateMachine = new StateMachine<AIViewSoldier>(this); 
      m_pStateMachine->SetCurrentState(IdleSoldier::Instance());

      m_pSteering=new SteeringBehaviors(this);
}

AIViewSoldier::~AIViewSoldier(void)
{
	if(mCreature) {
		delete mCreature;
	}
}


void AIViewSoldier::goToLocation(const Ogre::Vector3& goal, Cell* goalCell) {
    _currentCell = _navigationMesh->findCell(getCreature()->getPosition());
    
    _pathActive = _navigationMesh->buildPath(_path, getCreature()->getPosition(), goal, _currentCell, goalCell);
  	
    if(_pathActive)
		_pathIt = _path.begin(); 
    else
          m_pStateMachine->SetCurrentState(IdleSoldier::Instance());
}

SteeringBehaviors* AIViewSoldier::getSteeringBehaviors()
{
	return this->m_pSteering;
}

void AIViewSoldier::VOnUpdate( int deltaMilliseconds ) 
{
	
    /*envio el evento de ver*/

	GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Ver(mCreature,100,15)));
	

	mCreature->update(deltaMilliseconds);


	timeSinceLastFrame=(double)deltaMilliseconds/1000;

	m_pStateMachine->Update();
	closestObstacle=0;
	//evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(mCreature,Ogre::Vector3(100,0,0))));

}




  
