/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "DeerOwnedStates.h"
#include "AIViewDeer.h"
#include "Ogre.h"
#include "../Evt_Mover.h"


//--------------------------------------metodos para Wandering

Wandering* Wandering::Instance()
{
  static Wandering instance;

  return &instance;
}

void Wandering::Enter(AIViewDeer* pAIWiewDeer)
{
   
	pAIWiewDeer->getSteeringBehaviors()->wanderOn();
}


void Wandering::Execute(AIViewDeer* pAIWiewDeer)
{  
	
	
    Ogre::Vector2 velocity=pAIWiewDeer->addForce(pAIWiewDeer->getSteeringBehaviors()->PrioritiesAlgorithm());

    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	Ogre::Vector3 mov(velocity.x/800,0,Ogre::Math::Abs(velocity.y)/2);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewDeer->mCreature,mov)));
	
    
}


void Wandering::Exit(AIViewDeer* pAIWiewDeer)
{
	pAIWiewDeer->getSteeringBehaviors()->wanderOff();
} 

//----------------------------------------metodos para Seeking

Evading* Evading::Instance()
{
  static Evading instance;

  return &instance;
}


void Evading::Enter(AIViewDeer* pAIWiewDeer)
{  
	pAIWiewDeer->getSteeringBehaviors()->fleeOn();
}


void Evading::Execute(AIViewDeer* pAIWiewDeer)
{


	//si estamos ya a una cierta distancia del evasor

	if (Ogre::Vector2(pAIWiewDeer->target->getPosition().x,pAIWiewDeer->target->getPosition().z).squaredDistance(Ogre::Vector2(pAIWiewDeer->getCreature()->getPosition().x,pAIWiewDeer->getCreature()->getPosition().z))>20000)
	{
      pAIWiewDeer->GetFSM()->ChangeState(Wandering::Instance());
	}
	Ogre::Vector2 velocity=pAIWiewDeer->addForce(pAIWiewDeer->getSteeringBehaviors()->PrioritiesAlgorithm());

    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();

	Ogre::Vector3 mov(velocity.x,0,velocity.y);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIWiewDeer->mCreature,mov)));
	
}


void Evading::Exit(AIViewDeer* pAIWiewDeer)
{
	pAIWiewDeer->getSteeringBehaviors()->fleeOff();

}




