/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "State.h"
#include "SteeringBehaviors.h"

/**
 *  @author Hector Agustin Lana
 *  @date 14-01-2012
 *
 *  Estas clases modelan los estados de un ciervo
 *  
 */

class AIViewDeer;



class Wandering : public State<AIViewDeer>
{
private:

	Wandering(){}
  
  Wandering(const Wandering&);
  Wandering& operator=(const Wandering&);

public:

  //singleton
  static Wandering* Instance();

  virtual void Enter(AIViewDeer* pAIWiewDeer);

  virtual void Execute(AIViewDeer* pAIWiewDeer);

  virtual void Exit(AIViewDeer* pAIWiewDeer);
};


//------------------------------------------------------------------------
//
//------------------------------------------------------------------------

class Evading : public State<AIViewDeer>
{
private:
  
  Evading(){}

  
  Evading(const Evading&);
  Evading& operator=(const Evading&);

public:

  //singleton
  static Evading* Instance();

  virtual void Enter(AIViewDeer* pAIWiewDeer);

  virtual void Execute(AIViewDeer* pAIWiewDeer);

  virtual void Exit(AIViewDeer* pAIWiewDeer);
};