/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "DragonOwnedStates.h"
#include "AIViewDragon.h"
#include "Ogre.h"
#include "../Evt_Mover.h"
#include "../Evt_Atacar.h"


//--------------------------------------metodos para Wandering

IdleDragon* IdleDragon::Instance()
{
  static IdleDragon instance;

  return &instance;
}

void IdleDragon::Enter(AIViewDragon* pAIViewDragon)
{
	pAIViewDragon->getSteeringBehaviors()->wanderOn();	   
}


void IdleDragon::Execute(AIViewDragon* pAIViewDragon)
{  
	
      
	Ogre::Vector2 velocity=pAIViewDragon->addForce(pAIViewDragon->getSteeringBehaviors()->PrioritiesAlgorithm());

        GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
        
        Ogre::Vector3 mov(velocity.x/800,0,Ogre::Math::Abs(velocity.y)/2);

	evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIViewDragon->mCreature,mov)));
}


void IdleDragon::Exit(AIViewDragon* pAIViewDragon)
{
	pAIViewDragon->getSteeringBehaviors()->wanderOff();	
} 

//----------------------------------------metodos para SeekingDragon

SeekingDragon* SeekingDragon::Instance()
{
  static SeekingDragon instance;

  return &instance;
}


void SeekingDragon::Enter(AIViewDragon* pAIViewDragon)
{  
	pAIViewDragon->getSteeringBehaviors()->seekOn();	
}


void SeekingDragon::Execute(AIViewDragon* pAIViewDragon)
{
        //aumentamos el tiempo desde el ultimo ataque
    GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
    pAIViewDragon-> setTimeSinceLastAttack(pAIViewDragon->getTimeSinceLastAttack()+pAIViewDragon->getTimeSinceLastFrame());
       
        
        
    if (!pAIViewDragon->isAttacking())
      {
       //atacamos si podemos
       
         if (pAIViewDragon->canAttack())
         {
                 
               pAIViewDragon->Attacking=true;
               pAIViewDragon->getCreature()->setState(Creature::ATTACK1,false);
          }
         
             //perseguimos al target
	   Ogre::Vector2 velo=pAIViewDragon->addForce(pAIViewDragon->getSteeringBehaviors()->PrioritiesAlgorithm());
	   Ogre::Vector3 mov=Ogre::Vector3(velo.x,0,velo.y);
	   evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Mover(pAIViewDragon->mCreature,mov)));
       
       }
    else
      {
        pAIViewDragon->getCreature()->setState(Creature::ATTACK1,false);
        if (pAIViewDragon->canDamage())
        {
            //lanzamos los eventos de ataque
            printf("\n canAttack");
            Ogre::Vector3 direccion=pAIViewDragon->target->getPosition()-pAIViewDragon->getCreature()->getPosition();
            evtMgr->queueEvent(GardeGames::EventPtr( new Evt_Atacar(pAIViewDragon->getCreature(),pAIViewDragon->getCreature()->getAttack1(),direccion,2)));
            pAIViewDragon-> setTimeSinceLastAttack(0);
            pAIViewDragon->Attacking=false;
        }
     

      }
	
}


void SeekingDragon::Exit(AIViewDragon* pAIViewDragon)
{
		pAIViewDragon->getSteeringBehaviors()->seekOff();
                pAIViewDragon->timeSinceLastAttack=MIN_TIME_BETWEEN_ATTACKS;
}

