/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Héctor Agustín Lana (C) 2012
 * <hectoragustin89@hotmail.com
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "State.h"
#include "SteeringBehaviors.h"


class AIViewDragon;


/**
 *  @author Hector Agustin Lana
 *  @date 14-01-2012
 *
 *  Estas clases modelan los estados de un dragon
 *  
 */
class IdleDragon : public State<AIViewDragon>
{
private:

	IdleDragon(){}
  
 IdleDragon(const IdleDragon&);
  IdleDragon& operator=(const IdleDragon&);

public:

 
  static IdleDragon* Instance();

  virtual void Enter(AIViewDragon* pAIViewDragon);

  virtual void Execute(AIViewDragon* pAIViewDragon);

  virtual void Exit(AIViewDragon* pAIViewDragon);
};


//------------------------------------------------------------------------
//
//------------------------------------------------------------------------

class SeekingDragon : public State<AIViewDragon>
{
private:
  
  SeekingDragon(){}

  
 SeekingDragon(const SeekingDragon&);
  SeekingDragon& operator=(const SeekingDragon&);

public:

  
  static SeekingDragon* Instance();

  virtual void Enter(AIViewDragon* pAIViewDragon);

  virtual void Execute(AIViewDragon* pAIViewDragon);

  virtual void Exit(AIViewDragon* pAIViewDragon);
};

