#include "MeleeAttack.h"
#include "GardeGames/GardeGames.h"
#include "Creature.h"
#include "Evt_AplicarAtaque.h"

MeleeAttack::MeleeAttack(float range, float damage, int manaCost)
	: Attack(Attack::MELEE,range,damage,manaCost)
{
	mTarget=0;
}

MeleeAttack::~MeleeAttack(void)
{
}


void MeleeAttack::executeAttack(GameActor* target) {
	if (target) {
		mTarget=target;
	}
	Attack::executeAttack();
}

GameActor* MeleeAttack::getTarget() {
	return mTarget;
}

void MeleeAttack::update(float elapsedTime)
{
	if (getTarget()) {
		GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
		try {
			Creature* atacante=dynamic_cast<Creature*>(getOwner());
			Creature* atacado=dynamic_cast<Creature*>(getTarget());
			if (atacado) {
				evtMgr->queueEvent(GardeGames::EventPtr( new Evt_AplicarAtaque(atacante,atacado,this)));
			}
		}
		catch (Ogre::Exception &e){}
	}
	finalizeAttack();
}