#include "RangeAttack.h"
#include "GardeGames/GardeGames.h"
#include "Creature.h"
#include "Evt_AplicarAtaque.h"

RangeAttack::RangeAttack(float range, float damage, int manaCost, Ogre::SceneNode* proyectil)
: Attack(Attack::RANGE,range,damage,manaCost)
{
	mTarget=0;
	mProyectil=proyectil;
	mProyectil->setVisible(false);
}

RangeAttack::~RangeAttack(void)
{
}

void RangeAttack::executeAttack(GameActor* target) {
	if (target) {
		mTarget=target;
	}
	else {
		mTarget=0;
	}
//	mProyectil->setOrientation(getOwner()->getNode()->getOrientation());
	mProyectil->setPosition(getOwner()->getPosition());
	mProyectil->setVisible(true);

	Attack::executeAttack();
}

GameActor* RangeAttack::getTarget() {
	return mTarget;
}

void RangeAttack::update(float elapsedTime)
{
	if (getTarget()) {
		//mover proyectil hacia objetivo
		Ogre::Vector3 nuevaPos(0,0,-5);//=getTarget()->getPosition()-mProyectil->getPosition();
		mProyectil->lookAt(getTarget()->getPosition(),Ogre::Node::TS_WORLD);
		//nuevaPos.normalise();
		//nuevaPos*=5;
		nuevaPos=mProyectil->convertLocalToWorldPosition(nuevaPos);
		mProyectil->setPosition(nuevaPos);
		if (mProyectil->getPosition().distance(getTarget()->getPosition())<10) {
			GardeGames::IEventManager *evtMgr=GardeGames::IEventManager::Get();
			try {
				Creature* atacante=dynamic_cast<Creature*>(getOwner());
				Creature* atacado=dynamic_cast<Creature*>(getTarget());
				if (atacado) {
					evtMgr->queueEvent(GardeGames::EventPtr( new Evt_AplicarAtaque(atacante,atacado,this)));
				}
			}
			catch (Ogre::Exception &e){}
			finalizeAttack();			
			mProyectil->setVisible(false);
		}
	}
	else {		
		Ogre::Vector3 nuevaPos(0,0,5);
		nuevaPos=mProyectil->convertLocalToWorldPosition(nuevaPos);
		mProyectil->setPosition(nuevaPos);
		if (mProyectil->getPosition().distance(getOwner()->getPosition())>1050) {
			finalizeAttack();
			mProyectil->setVisible(false);
		}
	}
	
}