/*
 * This file is part of ElSoldadoYLaElfa.
 *
 * 
 * Miguel Garde Vallés (C) 2012
 * <miguelgardev@gmail.com>
 *
 * 
 * ElSoldadoYLaElfa examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * ElSoldadoYLaElfa examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ElSoldadoYLaElfa examples.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "GameActor.h"
#include "Ogre.h"
#include "PHYSICS/shape.h"

//! Clase que representa los seres inertes del juego.


/**
 *  @author Miguel Garde Vallés
 *  @date 14-01-2012
 *
 *  Modela los seres inertes dentro del juego, casas, árboles, piedras, etc.
 *  
 *  Hereda de la clase principal, GameActor, y se caracteriza porque no tiene vistas asociadas (no hay comportamientos).
 * 
 */

class StaticActor : public GameActor
{
public:
	StaticActor(int id, Ogre::SceneNode* node, ActorType type, Shape* shape);
	~StaticActor(void);

        double getRadius();
        
private:
	//Critter::Body* mBody;
};
